package ru.ifmo.genetics.io.formats;

public class Sanger implements QualityFormat {
	@Override
	public byte getPhred(char c) {
		if (c < 33 || c > 126) {
			throw new RuntimeException("Invalid quality code char: \"" + c + "\"" + " char code = " + ((int) c));
		}
		return (byte) (c - 33);
	}

	@Override
	public double getProbability(char c) {
		return Math.pow(10, getPhred(c) / -10.0);
	}
    
    public String toString() {
        return "SangerQF";
    }
}
