package ru.ifmo.genetics.tools.assembling.task;

import ru.ifmo.genetics.dna.DnaQ;
import ru.ifmo.genetics.utils.pairs.UniPair;
import ru.ifmo.genetics.tools.CompactDeBruijnGraph;

import java.util.List;
import java.util.Queue;

public class GlobalContext {
    final Queue<List<DnaQ>> queue;
    final Queue<List<UniPair<DnaQ>>> failedQueue;
    final int k;
    
    final int maxFragmentSize; // = averageFragmentSize + fragmentSizeDeviation;
    final int minFragmentSize; // = averageFragmentSize - fragmentSizeDeviation;
    
    final long toVertexMask;
    final int dnaBuilderCapacity;
    
    final CompactDeBruijnGraph graph;

    public GlobalContext(Queue<List<DnaQ>> queue, Queue<List<UniPair<DnaQ>>> failedQueue,
                         int k, int minFragmentSize,
            int maxFragmentSize, CompactDeBruijnGraph graph) {
        this.queue = queue;
        this.failedQueue = failedQueue;
        this.k = k;
        this.minFragmentSize = minFragmentSize;
        this.maxFragmentSize = maxFragmentSize;
        this.graph = graph;

        toVertexMask = (1L << (2 * k)) - 1;
        dnaBuilderCapacity = maxFragmentSize; 
    }
}
