package ru.ifmo.genetics.tools.longReadsAssembler;

import org.apache.hadoop.io.Text;
import org.apache.hadoop.util.LineReader;
import ru.ifmo.genetics.distributed.io.writable.DnaWritable;
import ru.ifmo.genetics.dna.Dna;

import java.io.*;
import java.util.ArrayList;

public class ReadsPlainReader {


    public static ArrayList<Dna> loadReadsAndAddRC(String readsFile) throws IOException {

        Text line = new Text();

        LineReader reader = new LineReader(new BufferedInputStream(new FileInputStream(readsFile)));



        ArrayList<Dna> reads = new ArrayList<Dna>();//(100000000);
        DnaWritable tempDna = new DnaWritable();
        
        while (reader.readLine(line) != 0) { // skips heads
            reader.readLine(line); // reads dna
            tempDna.set(line);
            Dna dna = new Dna(tempDna);
            reads.add(dna);
            reads.add(dna.reverseComplement());
        }
        
        reader.close();
        return reads;
    }

    private static StringBuffer readLine(BufferedReader in, StringBuffer s) throws IOException {
        s.delete(0, s.length());
        while (true) {
            int c = in.read();
            if ((c == -1) || (c == '\n')) {
                break;
            }
            s.append((char)c);
        }
        return s;
    }
}
