package ru.ifmo.genetics.tools.longReadsAssembler.overlaps;

public class AddingTask implements  Runnable {
    Overlaps overlaps;
    FullOverlapsList task;
    boolean rawAdding;

    public AddingTask(Overlaps overlaps, FullOverlapsList task, boolean rawAdding) {
        this.overlaps = overlaps;
        this.task = task;
        this.rawAdding = rawAdding;
    }

    @Override
    public void run() {
        for (int i = 0; i < task.size(); ++i) {
            int from = task.getFrom(i);
            int to = task.getTo(i);

            if (to == -1) {
                overlaps.markReadRemoved(from);
                continue;
            }

            if (rawAdding) {
                overlaps.addRawOverlapWithSync(from, to, task.getShift(i));
            } else {
                overlaps.addOverlapWithSync(from, to, task.getShift(i));
            }
        }
    }
}
