package ru.ifmo.genetics.utils;

import org.apache.hadoop.mapred.LineRecordReader;
import org.apache.hadoop.util.LineReader;
import ru.ifmo.genetics.tools.longReadsAssembler.ReaderInSmallMemory;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;

public class Misc {
    public static long availableMemory() {
        Runtime rt = Runtime.getRuntime();
        System.gc();
        return rt.maxMemory() - rt.totalMemory() + rt.freeMemory();
    }

    public static int signum(int x) {
        if (x < 0)
            return -1;
        if (x > 0)
            return 1;
        return 0;
    }

    public static long linesNumber(String overlapsFile) throws IOException {
        long linesNumber = 0;
        final int BUF_SIZE = 8196;
        byte[] buf = new byte[BUF_SIZE];
        
        BufferedInputStream is = new BufferedInputStream(new FileInputStream(overlapsFile));
        
        while (true) {
            int read = is.read(buf);
            if (read == -1) {
                break;                
            }
            for (int i = 0; i < read; ++i) {
                if (buf[i] == 0x0A) {
                    linesNumber++;
                }
            }
        }
        is.close();
        return linesNumber;
    }

    /**
     * Compares prefixes of arrays.
     * 
     * @param a
     * @param aLength
     * @param b
     * @param bLength
     * @return
     */
    public static boolean equals(int[] a, int aLength, int[] b, int bLength) {
        if (aLength != bLength) {
            return false;
        }
        
        for (int i = 0; i < aLength; ++i) {
            if (a[i] != b[i]) {
                return false;
            }
        }
        return true;
    }

    /**
     * Calculate hash code for array's prefix
     * 
     * @param a
     * @param aLength
     * @return
     */
    public static int hashCode(int[] a, int aLength) {
        int res = 0;
        
        for (int i = 0; i < aLength; ++i) {
            res *= 31;
            res += a[i];
        }
        return res;
    }
}
