package ru.ifmo.genetics.utils.pairs;

import ru.ifmo.genetics.io.sources.Source;
import ru.ifmo.genetics.utils.pairs.Pair;

import java.util.Iterator;
import java.util.NoSuchElementException;

public class UniPair<D> implements Source<D>, Pair<D, D> {
	public final D first, second;

	public UniPair(D a, D b) {
		this.first = a;
		this.second = b;
	}
	
	@Override
	public Iterator<D> iterator() {
		return new MyIterator();
	}

    @Override
    public D first() {
        return first;
    }

    @Override
    public D second() {
        return second;
    }

    class MyIterator implements Iterator<D> {
		byte n = 0;
		
		@Override
		public boolean hasNext() {
			return (n < 2);
		}

		@Override
		public D next() {
			switch (n++) {
				case 0: return first;
				case 1: return second;
				default: throw new NoSuchElementException();
			}
		}

		@Override
		public void remove() {
			throw new UnsupportedOperationException();
		}
	}
}
